import { ElementRef, EventEmitter, NgZone, OnChanges, OnDestroy, SimpleChanges } from '@angular/core';
import { Chart, ChartConfiguration, ChartEvent } from 'chart.js';
import { ThemeService } from './theme.service';
export declare class BaseChartDirective implements OnDestroy, OnChanges {
    private element;
    private zone;
    private themeService;
    type: ChartConfiguration['type'];
    legend: boolean;
    data: ChartConfiguration['data'];
    options?: ChartConfiguration['options'];
    plugins?: ChartConfiguration['plugins'];
    labels?: ChartConfiguration['data']['labels'];
    datasets?: ChartConfiguration['data']['datasets'];
    chartClick: EventEmitter<{
        event?: ChartEvent;
        active?: {}[];
    }>;
    chartHover: EventEmitter<{
        event: ChartEvent;
        active: {}[];
    }>;
    ctx: string;
    chart: Chart;
    private subs;
    private themeOverrides;
    constructor(element: ElementRef, zone: NgZone, themeService: ThemeService);
    ngOnChanges(changes: SimpleChanges): void;
    ngOnDestroy(): void;
    render(): Chart;
    update(duration?: any): void;
    hideDataset(index: number, hidden: boolean): void;
    isDatasetHidden(index: number): boolean;
    toBase64Image(): string;
    private themeChanged;
    private getChartOptions;
    private getChartConfiguration;
}
